/**************************************************************
** 	Mini
**	ܣLCDʾʵ
**  汾V3.0  
**	www.openmcu.com
**	䣺support@openmcu.com   
**  ̳bbs.openmcu.com
***************************************************************/  

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hardware.h"
#include "usart.h"
#include "ili932x.h"
#include <stdio.h>
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
extern uint8_t gImage_11[];

static __IO uint32_t TimingDelay;
/* Private function prototypes -----------------------------------------------*/
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void TIM_Configuration(void);
uint8_t KEY_Scan(void);
void Delay(__IO uint32_t nTime);
/* Private functions ---------------------------------------------------------*/

/*****************************************************************************
** : main
** : 
**   : Dream
** ա  : 20101217
*****************************************************************************/
int main(void)
{
	int x = 0;
	SystemInit();	   		//ϵͳʱ72M(clock, PLL and Flash configuration)
	while(SysTick_Config(SystemFrequency / 1000));	//Systick ʱn*ms
	GPIO_Configuration();	// 
	NVIC_Configuration();	//ϵͳж
	TIM_Configuration();	//ʱ2ʼ
	USART_Configuration();	//첽ͨųʼ
	LCD_Init();					// LCDʼ	
  	while (1)
  	{
			switch(x)
		{
			case 0:LCD_Clear(WHITE);break;
			case 1:LCD_Clear(BLACK);break;
			case 2:LCD_Clear(BLUE);break;
			case 3:LCD_Clear(MAGENTA);break;
			case 4:LCD_Clear(BRRED);break; 
			case 5:LCD_Clear(GREEN);break;
		}	    					 
	    x++;
		if(x==6)
		{
			x=0;
		} 
		LED1 =!LED1;
		Delay(100);		//ʱ1000MS	
  	}
}
/*****************************************************************************
** : GPIO_Configuration
** : IO
**   : Dream
** ա  : 20101217
*****************************************************************************/
void GPIO_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1
							, ENABLE);	// ʹܶ˿ʱӣҪ 
	
	/*  LED1LED2ŵĹ *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2 | GPIO_Pin_3;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		//ͨģʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		//ƵΪ50MHz
  	GPIO_Init(GPIOA, &GPIO_InitStructure);					//ʼPA2PA3

	/*  KEY1KEY2ŵĹ *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;			//ģʽ
  	GPIO_Init(GPIOA, &GPIO_InitStructure);					//ʼPA0PA1


   	/*  USART1 Tx (PA9) */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	 		//ÿ©ģʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		//ƵΪ50MHz
  	GPIO_Init(GPIOA, &GPIO_InitStructure);
    
  	/*  USART1 Rx (PA10)  */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	//ģʽ
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

}
/*****************************************************************************
** : TIM_Configuration
** : ʱ
				1usһ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void TIM_Configuration(void) 
{ 
	TIM_TimeBaseInitTypeDef TIM_BaseInitStructure; 
	
	TIM_DeInit( TIM2);                              //λTIM2ʱ 
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);   //ʹܶʱ2   
	//TIM2 ʹڲʱ 
	//TIM_InternalClockConfig(TIM1); 
	//TIM2 
	//ԤƵƵϵ71APB2=72M, TIM1_CLK=72/72=1MHz 
	//TIM_PeriodTIM1_ARR=1000ϼ1000¼ֵ 
	//ϼģʽ 
	//TIM_RepetitionCounter(TIM1_RCR)=0ÿ¼ 
	TIM_BaseInitStructure.TIM_Period = 1000; 		//ԶؼĴֵΪֵ
	TIM_BaseInitStructure.TIM_Prescaler = 71;  		//ԶԤƵ
	TIM_BaseInitStructure.TIM_ClockDivision = 0; 
	TIM_BaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;   //ϼģʽ
	TIM_BaseInitStructure.TIM_RepetitionCounter = 0; 
	TIM_TimeBaseInit(TIM2, &TIM_BaseInitStructure); 
	
	//жϣһжϺж 
	TIM_ClearFlag(TIM2, TIM_FLAG_Update); 
	//ʹTIM2жԴ 
	TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE); 
	//TIM2ܿأ 
	TIM_Cmd(TIM2, ENABLE); 
}
/*****************************************************************************
** : TIM2_IRQHandler
** : ʱ2жϴ
				1usһ
**   : Dream
** ա  : 20101217
*****************************************************************************/ 
uint16_t tick ;                     // tick counter
uint8_t count;
void TIM2_IRQHandler(void)
{
	static uint8_t count=0;
	if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) 
    {
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update);       
 	  	tick++;
	  	count++;
	  	if(count==30)
		{
			LED2 =!LED2;			
		}
	}
}
/*****************************************************************************
** : KEY_Scan
** : 
				0ûκΰ	  1KEY1 
				 2KEY2 
**   : Dream
** ա  : 20101217
*****************************************************************************/
uint8_t KEY_Scan(void)
{	 
	static uint8_t KEY_UP=1;	//ɿ־	   
	if(KEY_UP&&(KEY1==0||KEY2==0))
	{
		Delay(10);				//ȥ 
		KEY_UP=0;
		if(KEY1==0)return 1;
		else if(KEY2==0)return 2;
	}else if(KEY1==1&&KEY2==1)KEY_UP=1; 	    
	return 0;					//ް
}
/*****************************************************************************
** : Delay
** : Systickʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void Delay(__IO uint32_t nTime)
{ 
  TimingDelay = nTime;

  while(TimingDelay != 0);
}
/*****************************************************************************
** : TimingDelay_Decrement
** : SystickжϽ뺯
**   : Dream
** ա  : 20101217
*****************************************************************************/
void TimingDelay_Decrement(void)
{
  if (TimingDelay != 0x00)
  { 
    TimingDelay--;
  }
}
/*****************************************************************************
** : NVIC_Configuration
** : ϵͳжϹ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void NVIC_Configuration(void)
{
  	NVIC_InitTypeDef NVIC_InitStructure;

	#ifdef  VECT_TAB_RAM  
	  /* Set the Vector Table base location at 0x20000000 */ 
	  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
	#else  /* VECT_TAB_FLASH  */
	  /* Set the Vector Table base location at 0x08000000 */ 
	  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
	#endif

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0); 	   //жΪ0

	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;    //¼ 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ0 
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;          //Ӧȼ1 
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;             //ж 
	NVIC_Init(&NVIC_InitStructure);                             //д 
}
/*****************************************************************************
** : EXTI0_IRQHandler
** : ⲿж0
				жϺ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void EXTI0_IRQHandler(void)
{ 
   
  	if(EXTI_GetITStatus(EXTI_IMR_MR0) != RESET)
  	{	 
		Delay(50); //ʱȡ
		if(KEY1==0)
		{
			LED1 =!LED1; //LED1ת
		}
    	EXTI_ClearITPendingBit(EXTI_IMR_MR0);	 //LINE13ϵжϱ־λ 
  	}
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval : None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*******************************************************************************
** End of File
********************************************************************************/
